#ifndef TARTMAPPPER_H
#define TARTMAPPPER_H

// mapper 

#include <map>
#include "TArtMap.h"
#include "TArtCore.h"

class TArtMapper  {

protected:

  // for anaroot style mapping for reconstruction
  std::map<TArtRIDFMap, unsigned int *> recomap;
  std::map<TArtRIDFMap, unsigned int *>::iterator ritrEnd;
  std::map<TArtRIDFMap, unsigned int *>::iterator rmap;

  // for anapaw style mapping

  std::map<TArtRIDFMap, TArtMap> anamap;
  std::map<TArtRIDFMap, TArtMap>::iterator itrEnd;
  std::map<TArtRIDFMap, TArtMap>::iterator amap;

  TArtMapper();
  static TArtMapper* sMapper;

public:
  static TArtMapper* Instance();
  virtual ~TArtMapper();
  virtual bool isRecoLoaded();
  virtual void LoadRecoConfig(TArtRIDFMap *map, unsigned int *p);
  virtual void LoadRecoConfig(int fp,int detid,int geo,int ch,unsigned int *p);
  virtual unsigned int * FindRecoMap(TArtRIDFMap * inmap);
  virtual unsigned int * FindRecoMap(int fp,int detid,int geo,int ch);

  virtual bool isLoaded();
  virtual void LoadConfig(const char* filename);
  virtual TArtMap * FindMap(TArtRIDFMap * inmap);
  virtual TArtMap * FindMap(int fp,int detid,int geo,int ch);

};

#endif // end of #ifdef TARTMAPPER_H
